import requests
import re
import pandas as pd
import os
import pandas as pd
import requests
import sys
import os
import pycurl
import json
from io import BytesIO
import datetime
import certifi


def readAllChannels(fileName,token):
    data = pd.read_csv(fileName)
    channels = []
    removed_channels=[]
    dic_values={}
    for index, row in data.iterrows():
        Community = row["Community"]
        Channel = row["Channel Name"]
        room_name = Community+"/"+Channel
        try:
            roomID, groupID = getRoomIdByURI(token, room_name)
            if Community in dic_values:
                old_list=dic_values[Community]
                if not groupID in old_list:
                    dic_values[Community].append(groupID)
            else:
                dic_values[Community]=groupID
        except Exception as e:
            print(Channel,"'s Group ID is not valid")

        # if index == 3:
        #     break

    return dic_values

def getRoomIdByURI(token, chatRoomURI):
    myBuffer = BytesIO()
    headers = ['Authorization: Bearer {}'.format(token),
               'Content-Type: application/json',
               'Accept: application/json']

    curlConnect = pycurl.Curl()
    curlConnect.setopt(pycurl.CAINFO, certifi.where())
    curlConnect.setopt(pycurl.URL, 'https://api.gitter.im/v1/rooms')
    curlConnect.setopt(pycurl.POST, 1)
    curlConnect.setopt(pycurl.HTTPHEADER, headers)
    curlConnect.setopt(pycurl.POSTFIELDS, json.dumps({'uri': '{}'.format(chatRoomURI)}))
    curlConnect.setopt(pycurl.WRITEDATA, myBuffer)
    curlConnect.perform()

    print(curlConnect.getinfo(pycurl.HTTP_CODE))
    # --> 200
    print(curlConnect.getinfo(pycurl.EFFECTIVE_URL))
    # --> "https://www.python.org/"
    certinfo = curlConnect.getinfo(pycurl.INFO_CERTINFO)
    print("certinfo: {} ".format(certinfo))

    curlConnect.close()
    body = json.loads(myBuffer.getvalue().decode())
    room_id = body['id']
    group_id = body['groupId']
    #print("{} group id:".format(chatRoomURI), room_id)
    return room_id, group_id

def findGroupInformation(token,groupID):
    r = requests.get("https://api.gitter.im/v1/groups/{}/rooms?access_token={}".format(groupID, token))
    rooms=[]
    total_rooms=0
    total_users=0
    for i in r.json():
        total_rooms+=1
        total_users+=i["userCount"]

    for meta in r.json():
        # print("username:", meta["id"])
        rooms.append((meta["topic"], meta["userCount"],total_rooms,total_users, meta["name"]))
    return rooms

if __name__ == '__main__':
    token = ''
    #TODO: get # of messages per room.
    rows=[]
    column_name = ['Community','Total Rooms (Channels)','Total Users in Community', 'Channel Name',"Total Users In That Channel" ,"Channel Desc."]
    channelsInfo = readAllChannels("communities_details.csv",token)
    rows=[]

    for key, value in channelsInfo.items():
        community=key
        group_id=value #cannot be more than one group? check?
        if len(group_id)>1:
            print("ERROR"*50, community)
        group_info = findGroupInformation(token, group_id)
        for i in group_info:
            #update total users
            rows.append((community,i[2], i[3],i[4],i[1],i[0]))
    dev_df = pd.DataFrame(rows, columns=column_name)
    dev_df.to_csv("communities_details.csv", index=None)
    print(dev_df)



