import pandas as pd

def findStats(fileName):
    aggregation = {
        "Total Rooms (Channels)":
            {
                "MIN": lambda x: x.min(skipna=True),
                "MAX": lambda x: x.max(skipna=True),
                "MEDIAN": lambda x: x.median(skipna=True),
                "MEAN": lambda x: x.mean(skipna=True)
            }
    }
    df = pd.read_csv(fileName)
    results={}

    results["Gitter and Github Users (Intersection)"]=[df['Gitter and Github Users'].min(),df['Gitter and Github Users'].max(),df['Gitter and Github Users'].sum(),df['Gitter and Github Users'].mean(),df['Gitter and Github Users'].median()]
    results["Github Users"]=[df['Github Users'].min(),df['Github Users'].max(),df['Github Users'].sum(),df['Github Users'].mean(),df['Github Users'].median()]
    results["Gitter Users"]=[df['Gitter Users'].min(),df['Gitter Users'].max(),df['Gitter Users'].sum(),df['Gitter Users'].mean(),df['Gitter Users'].median()]

    return results


if __name__ == '__main__':
    results = findStats("Developers per Channel.csv")
    column  = ["Meta", "Min", "Max", "Sum","Mean","Median"]
    rows=[]
    for key, value in results.items():
        rows.append((key,value[0],value[1],value[2],value[3],value[4]))
        print(rows)
    dev_df = pd.DataFrame(rows, columns=column)
    dev_df.to_csv("Developers_Channel_stats.csv", index=None)



