import csv



# File format
# row[0] -> system
# row[1] -> messageId
# row[2] -> time
# row[3] -> user
# row[4] -> message
# row[5] -> Purpose
# row[6] -> Category
# row[7] -> Subcategory
import re


def users_per_category(file):
    with open(file) as dataset:
        csv_reader = csv.reader(dataset,delimiter=',')
        next(csv_reader)
        users_data = {}
        for row in csv_reader:
            user = row[3]
            label = row[6]
           # print(user, label)
            if user not in users_data.keys():
                users_data[user] = [label]
            else:
                current_labels = users_data[user]
                if label not in current_labels:
                    current_labels.append(label)
                    users_data[user] = current_labels
        print(users_data)

        print(len(users_data.keys()))


        #Loop to count number of users per category
        label_users = {}
        for user in users_data.keys():
            current_categories = label_users.keys()
            for label in users_data[user]:
                if label not in current_categories:
                    label_users[label] = [user]
                else:
                    current_label_user_list = label_users[label]
                    current_label_user_list.append(user)
                    label_users[label] = current_label_user_list

        print(label_users)

        label_count = {}
        for label in label_users.keys():
            label_count[label] = len(label_users[label])

        print(label_count)


def users_per_category_per_system(file):
    system_dict = {}
    with open(file) as dataset:
        csv_reader = csv.reader(dataset, delimiter=',')
        next(csv_reader)
        users_data = {}
        current_system = 'None'
        for row in csv_reader:
            system = row[0]
            if current_system == 'None':
                current_system = system
            if system != current_system:
                system_dict[current_system] = users_data
                users_data = {}
                current_system = system
            user = row[3]
            label = row[6]
            # print(user, label)
            if user not in users_data.keys():
                users_data[user] = [label]
            else:
                current_labels = users_data[user]
                if label not in current_labels:
                    current_labels.append(label)
                    users_data[user] = current_labels
        # print(users_data)
        # print(len(users_data.keys()))
        # print(system_dict)

        for sys in system_dict.keys():
            # Loop to count number of users per category
            users_data = system_dict[sys]
            label_users = {}
            for user in users_data.keys():
                current_categories = label_users.keys()
                for label in users_data[user]:
                    if label not in current_categories:
                        label_users[label] = [user]
                    else:
                        current_label_user_list = label_users[label]
                        current_label_user_list.append(user)
                        label_users[label] = current_label_user_list

            label_count = {}
            for label in label_users.keys():
                label_count[label] = len(label_users[label])
            print("Users per category for {0} with {1} developers".format(sys, len(users_data.keys())))
            # print(label_users)
            # print(len(users_data.keys()))
            print(label_count)


def vocabulary_overlap(file):
    with open(file) as dataset:
        csv_reader = csv.reader(dataset, delimiter=',')
        next(csv_reader)
        per_category_data = {}
        per_category_vocab = {}
        current_system = 'None'
        for row in csv_reader:
            system = row[0]
            category = row[6]
            message = row[4]
            if category not in per_category_data.keys():
                per_category_data[category] = [message]
            else:
                current_category_message_list = per_category_data[category]
                current_category_message_list.append(message)
                per_category_data[category] = current_category_message_list
        print(per_category_data)

        for cat in per_category_data.keys():
            # print(cat)
            # print(per_category_data[cat])
            for msg in per_category_data[cat]:
                words = msg.split()
                for w in words:
                    w = re.sub('[^A-Za-z0-9]+', '', w)
                    if cat not in per_category_vocab.keys():
                        per_category_vocab[cat] = [w]
                    else:
                        current_category_vocab_list = per_category_vocab[cat]
                        current_category_vocab_list.append(w)
                        per_category_vocab[cat] = current_category_vocab_list

        for cat in per_category_vocab.keys():
            for cat2 in per_category_vocab.keys():
                if cat2 != cat:
                    over = intersection(per_category_vocab[cat], per_category_vocab[cat2])
                    print("Overlap {0}/{1}: {2} terms".format(cat,cat2,len(over)))
                    print(over)


# https://www.geeksforgeeks.org/python-intersection-two-lists/
def intersection(lst1, lst2):
    lst3 = [value for value in lst1 if value in lst2]
    return lst3


def main():
    users_per_category('GitterCom.csv')
    users_per_category_per_system('GitterCom.csv')
    vocabulary_overlap('GitterCom.csv')


if __name__ == "__main__":
    main()

